unit Navedit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Mask, Popedits, StdCtrls, Buttons, Spin, Navigate,
  ExtCtrls;

type
  TNavEditForm = class(TForm)
    Panel1: TPanel;
    Navigator1: TNavigator;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label4: TLabel;
    PopupEdit1: TPopupEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    OpenDialog1: TOpenDialog;
    Bevel1: TBevel;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    procedure Memo1Exit(Sender: TObject);
    procedure Memo2Exit(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure PopupEdit1BtnClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateNavigator;
  public
    { Public declarations }
  end;

var
  NavEditForm: TNavEditForm;

implementation

{$R *.DFM}

procedure TNavEditForm.FormCreate(Sender: TObject);
begin
  Memo1.Lines.Assign(Navigator1.Buttons);
  Memo2.Lines.Assign(Navigator1.Hints);
end;

procedure TNavEditForm.UpdateNavigator;
begin
  Navigator1.Buttons := TStringList(Memo1.Lines);
  Navigator1.Hints := TStringList(Memo2.Lines);
  Navigator1.UseCaptions := CheckBox1.Checked;
end;

procedure TNavEditForm.Memo1Exit(Sender: TObject);
begin
  if Memo1.Modified then UpdateNavigator;
end;

procedure TNavEditForm.Memo2Exit(Sender: TObject);
begin
  if Memo2.Modified then UpdateNavigator;
end;

procedure TNavEditForm.CheckBox1Click(Sender: TObject);
begin
  UpDateNavigator;
end;

procedure TNavEditForm.CheckBox2Click(Sender: TObject);
begin
  Navigator1.ShowHint := CheckBox2.Checked;
end;

procedure TNavEditForm.SpinEdit1Change(Sender: TObject);
var
  i: integer;
begin
  if SpinEdit1.Text <> '' then
  begin
    Memo1.Clear;
    Memo2.Clear;
    for i := 0 to (Sender as TSpinEdit).Value-1 do
      Memo1.Lines.Add('Button'+IntToStr(i+1));
    UpdateNavigator;
  end;
end;

procedure TNavEditForm.PopupEdit1BtnClick(Sender: TObject);
var
  Temp: TBitMap;
begin
  if OpenDialog1.Execute then
  begin
    Temp := TBitMap.Create;
    Temp.LoadFromFile(OpenDialog1.FileName);
    PopupEdit1.Text := OpenDialog1.FileName;
    Navigator1.Glyphs := Temp;
  end;
end;

procedure TNavEditForm.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TNavEditForm.BitBtn4Click(Sender: TObject);
var
  Writer: TWriter;
  Stream: TFileStream;
begin
  if SaveDialog1.Execute then
  begin
    Stream := TFileStream.Create(SaveDialog1.FileName, fmCreate);
    Writer := TWriter.Create(Stream, 4096);
    try
      Writer.WriteSignature;
      Writer.WriteComponent(Navigator1);
    finally
      Writer.Free;
      Stream.Free;
    end;
  end;
end;

procedure TNavEditForm.BitBtn5Click(Sender: TObject);
var
  Stream: TFileStream;
  Tmp: TNavigator;
begin
  if OpenDialog2.Execute then
  begin
    Stream := TFileStream.Create(OpenDialog2.FileName, fmOpenRead);
    Tmp := TNavigator.Create(nil);
    try
      Stream.ReadComponent(Tmp);
      SpinEdit1.Value := Tmp.Buttons.Count;
      Memo1.Lines.Assign(Tmp.Buttons);
      Memo2.Lines.Assign(Tmp.Hints);
      CheckBox1.Checked := Tmp.UseCaptions;
      CheckBox2.Checked := Tmp.ShowHint;
      Navigator1.Glyphs.Assign(Tmp.Glyphs);
      UpdateNavigator;
    finally
      Tmp.Free;
      Stream.Free;
    end;
  end;
end;

procedure TNavEditForm.BitBtn3Click(Sender: TObject);
begin
  Application.MessageBox('Help not implemented in this freeware version.'+
    ' Use the TNavigator Visual Editor to edit TNavigator.',
      'TNavigator Visual Editor Help',  MB_OK);
end;

end.
